<?php
function enable_dynamic()
{
	// based on http://www.phpied.com/javascript-include/ and http://www.phpit.net/article/ajax-php-without-xmlhttprequest/
	script("function dynamic(action)
{
document.body.style.cursor = 'wait';
window.dynamic_loading++;

timer_stop();

var html_doc = document.getElementsByTagName('head').item(0);
var js = document.createElement('script');
js.setAttribute('language', 'javascript');
js.setAttribute('type', 'text/javascript');
url = document.location.href;
xend = url.lastIndexOf(\"/\") + 1;
var base_url = url.substring(0, xend);
base_url = base_url + '?DYNAMIC=' + action;
js.setAttribute('src', base_url);
html_doc.appendChild(js);

document.body.style.cursor = 'default';
window.dynamic_loading--;
timer_start();
return false;
}");
}

// put a link on a page which when clicked will trigger a dynamic change
function get_dynalink($text, $dynamic, $prams = array())
{
	$pram = "";
	foreach($prams as $k => $v)
	{
		$pram.= "&amp;";
		$pram.= "$k=$v";
	}
	return "<span style=\"cursor: pointer\" onclick=\"dynamic('$dynamic$pram')\">$text</span>\n";
}

function dynamic_set_class($id, $class)
{
	echo "var x = document.getElementById(\"$id\");\n";
	echo "x.className=\"$class\";\n";
}

function dynamic_set_html($id, $s)
{
	echo "var x = document.getElementById(\"$id\");\n";
	$s = strtr($s, array("\n" => "\\n", "'" => "\\'"));
	echo "x.innerHTML='$s';\n";
}

function dynamic_show($msg)
{
	$msg = strtr($msg, array('"' => '\"', "\n" => "\\\n"));
	echo "confirm(\"$msg\"); ";
}

$DYNAMIC = array();
function check_dynamic()
{
	global $DYNAMIC;

	if(isset($_GET['DYNAMIC']))
	{
		if(in_array($_GET['DYNAMIC'], $DYNAMIC))
		{
			$function = 'dynamic_on_'.$_GET['DYNAMIC'];

			if(function_exists($function))
			{
				$msg = call_user_func($function);
			}
			else
			{
				$msg = "Function $function does not exist";
			}
		}
		else
		{
			$msg = "Function {$_GET['DYNAMIC']} is not registered";
		}

		if(isset($msg))
		{
			dynamic_show($msg);
		}

		die;
	}
}
?>
